-- complain if script is sourced in psql
-- rather than via CREATE EXTENSION
\echo USE "CREATE EXTENSION cc_sql" TO LOAD this file. \quit


CREATE FUNCTION cc_destination_in(cstring) RETURNS cc_destination
     AS 'MODULE_PATHNAME', 'cc_destination_in'
     LANGUAGE C IMMUTABLE STRICT;

CREATE FUNCTION cc_destination_out(cc_destination) RETURNS cstring
    AS 'MODULE_PATHNAME', 'cc_destination_out'
    LANGUAGE C IMMUTABLE STRICT;

CREATE TYPE cc_destination (
  internallength = 24,
  input          = cc_destination_in,
  output         = cc_destination_out
) ;

create type cc_sys_distribute_resource as
(
    resource_id bigint,
    limit_items integer,
    patterns varchar[]
);

create type cc_sys_distribute_type as
(
    type_id     bigint,
    resource_id bigint,
    offsets     smallint[],
    group_id int
);

create type cc_sys_distribute_bucket as
(
    bucket_id integer,
    count     integer,
    ins       boolean
);

CREATE FUNCTION cc_version() returns text
    AS 'MODULE_PATHNAME', 'cc_version'
    LANGUAGE C IMMUTABLE;

CREATE FUNCTION cc_destination_in(int4, int4, int8, int4, int4) RETURNS cc_destination
     AS 'MODULE_PATHNAME', 'cc_destination_in_args'
     LANGUAGE C IMMUTABLE CALLED ON NULL INPUT ;

CREATE FUNCTION cc_destination_id(cc_destination) RETURNS int4
     AS 'MODULE_PATHNAME', 'cc_destination_id'
     LANGUAGE C IMMUTABLE STRICT;

CREATE FUNCTION cc_destination_priority(cc_destination) RETURNS int4
     AS 'MODULE_PATHNAME', 'cc_destination_priority'
     LANGUAGE C IMMUTABLE STRICT;

CREATE FUNCTION cc_destination_type_id(cc_destination) RETURNS int4
     AS 'MODULE_PATHNAME', 'cc_destination_type_id'
     LANGUAGE C;


CREATE FUNCTION cc_sys_distribute() returns setof record
AS 'MODULE_PATHNAME', 'cc_sys_distribute'
    LANGUAGE C VOLATILE;

CREATE or replace function cc_distribute_init_queues_internal(internal, int, int, int, varchar, int2[],
                  cc_sys_distribute_resource[], cc_sys_distribute_type[],
                  cc_sys_distribute_bucket[], int, int2, bool, int4, int4, bool, bool, bool, int8) returns int
as 'MODULE_PATHNAME', 'cc_distribute_init_queues_internal'
    LANGUAGE C CALLED ON NULL INPUT;


CREATE FUNCTION cc_distribute_unique_qb(internal) returns setof record
AS 'MODULE_PATHNAME', 'cc_distribute_unique_qb'
    LANGUAGE C VOLATILE;

CREATE FUNCTION cc_distribute_agents(internal, int, int, int, int, int[]) returns setof record
AS 'MODULE_PATHNAME', 'cc_distribute_agents'
    LANGUAGE C VOLATILE;

CREATE FUNCTION cc_round_robin_bucket(internal, int, int, int) returns int8
AS
'MODULE_PATHNAME', 'cc_round_robin_bucket'
    LANGUAGE C IMMUTABLE;